import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import java.net.*;
import fiji.io.*;
import java.io.*;

/**
 * Estensione della classe JFrame, ovvero della classe necessaria per fare
 * delle applicazioni stand-alone con grafica Swing.
 *
 * @author Barbara Pettazzoni
 * @version 1.00 07/06/06
 */
public class GraphicConcessionariaFrame extends JFrame 
{
    
    	private JMenuBar menuBar;
        private JMenu menuFile;
        private JMenu menuCerca;
        private JMenuItem menuPrezzo;
        private JMenuItem menuColore;
        private JMenuItem menuTipo;
        private JMenuItem menuKm;
        private JMenuItem menuTutte;
        private JMenuItem menuFileExit;
        private Container contentPane = getContentPane();
        private ImagePanel mainPanel;
        private JTable table;
        private JScrollPane scrollPane;
        private DefaultTableModel model;
        private BufferedImage buffer;
        private Graphics g;
        private java.util.List<Auto> listAuto;
        private ButtonGroup group;
        private JRadioButton radio1, radio2;
        private java.util.List<Auto> currentList;
    
    /**
     * Il costruttore. I due metodi privati rispettivamente disegnano l'aspetto e associano gli
     * handler ai bottoni del menu e ai radio button.
     */  
     public GraphicConcessionariaFrame() 
     {
      		disegnaAspetto();
      		attivaEventi();               
     }
    
    private void disegnaAspetto()
    {
  		buffer = new BufferedImage(700,400,BufferedImage.TYPE_INT_RGB);
        g= buffer.getGraphics();
    	menuBar = new JMenuBar();
        menuFile = new JMenu();
        menuCerca = new JMenu("Cerca");
        menuFileExit = new JMenuItem();
   		menuTutte = new JMenuItem("Mostra tutte le auto");
   		menuKm = new JMenuItem("Mostra le auto inferiori a un certo chilometraggio");
   		menuPrezzo = new JMenuItem("Mostra le auto inferiori a un certo prezzo");
   		menuColore = new JMenuItem("Mostra le auto con un certo colore");
   		menuTipo = new JMenuItem("Mostra le auto di un certo tipo");
        menuFile.setText("File");
        menuFileExit.setText("Exit");
        menuCerca.add(menuTutte);
        menuCerca.add(menuPrezzo);
        menuCerca.add(menuKm);
        menuCerca.add(menuColore);
        menuCerca.add(menuTipo);
        menuFile.add(menuFileExit);
        menuBar.add(menuFile);
        menuBar.add(menuCerca);
        
        setTitle("Benvenuti alla Vend O'Tutt!!");
        setJMenuBar(menuBar);
        mainPanel = new ImagePanel(buffer,0,0);
        mainPanel.setBounds(0,0,700,400);
        g.setColor(Color.white);
        g.fillRect(0,0,700,400);
        try
        {
        	URL saetta = GraphicConcessionariaFrame.class.getResource("saetta.jpg");
        	g.setColor(Color.black);
        	g.setFont(new Font("Arial",Font.BOLD,20));
        	g.drawString("Benvenuti alla Vend O'Tutt!",350,50);
        	g.drawLine(480,75,480,130);
       		 g.drawImage(new ImageIcon(saetta).getImage(),400,100,null);
        }
        catch(Exception e)
        {
        	e.printStackTrace();
        }
        model = new DefaultTableModel();
        model.addColumn("Tipo");
        model.addColumn("Prezzo");
        model.addColumn("KM");
        model.addColumn("Colore");
        table = new JTable(model);
        scrollPane = new JScrollPane(table, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
        scrollPane.setBounds(30,30,290,300);
        radio1 = new JRadioButton("Prezzo > Chilometraggio > Colore > Nome");
        radio1.setBounds(350,230,300,30);
        radio1.setBackground(Color.white);
        radio2 = new JRadioButton("Chilometraggio > Prezzo > Nome > Colore");
        radio2.setBounds(350,270,300,30);
        radio2.setBackground(Color.white);
        group = new ButtonGroup();
        group.add(radio1);
        group.add(radio2);
        group.setSelected(radio1.getModel(),true);
        mainPanel.setLayout(null);
        mainPanel.add(scrollPane);
        mainPanel.add(radio1);
        mainPanel.add(radio2);
    //    b.paint();
        this.add(mainPanel);
        setSize(new Dimension(700, 400));
        leggiAuto();
        riempiTabella(currentList);
        setResizable(false);
        new AePlayWave("start.wav").start();
    }
    
    private void attivaEventi()
    {
    	this.addWindowListener
        (
            new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    GraphicConcessionariaFrame.this.windowClosed();
                }
            }
        );
        
        // Add action listener.for the menu button
        menuFileExit.addActionListener
        (
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    GraphicConcessionariaFrame.this.windowClosed();
                }
            }
        );
        menuTutte.addActionListener(
        new ActionListener()
        {
        	public void actionPerformed(ActionEvent e)
        	{
				cancellaTabella();
				riempiTabella(listAuto);
				currentList = listAuto;
        	}
        }
        );
        
        menuPrezzo.addActionListener(
        new ActionListener()
        {
        	public void actionPerformed(ActionEvent e)
        	{
        		cancellaTabella();
        		java.util.List<Auto> lista = new Vector<Auto>();
        		String result = (String)JOptionPane.showInputDialog(
                    GraphicConcessionariaFrame.this, 
                    "Inserisci il prezzo iniziale",
                    "Inserisci il prezzo iniziale",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    null,
                    11000);
                 if(result != null)
                 try
                 {
                	int maxPrezzo = Integer.parseInt(result);
                	if(maxPrezzo > 0)
                	{
	                	for(Auto auto : listAuto)
	                	{
	                		if(auto.getPrezzo() <= maxPrezzo)
	                			lista.add(auto);
	                	}
	                	riempiTabella(lista); 	
	                	currentList = lista;
	                }
	                else
	                {
	                	new AePlayWave("tristezza.wav").start();
	                	JOptionPane.showMessageDialog(GraphicConcessionariaFrame.this,
						    "Inserisci un valore superiore a 0!",
						    "Errore!",
						    JOptionPane.ERROR_MESSAGE);
					    currentList = null;
					}
                 }
                 catch(Exception exc)
                 {
					new AePlayWave("tristezza.wav").start();                 
                 	JOptionPane.showMessageDialog(GraphicConcessionariaFrame.this,
					    "Inserisci un valore superiore a 0!",
					    "Errore!",
					    JOptionPane.ERROR_MESSAGE);
					 currentList = null;
                 }
                 else
                 	currentList = null;
				
        	}
        }	
        );
        
        //km
        menuKm.addActionListener(
        new ActionListener()
        {
        	public void actionPerformed(ActionEvent e)
        	{
        		cancellaTabella();
        		java.util.List<Auto> lista = new Vector<Auto>();
        		String result = (String)JOptionPane.showInputDialog(
                    GraphicConcessionariaFrame.this, 
                    "Inserisci il massimo chilometraggio",
                    "Inserisci il massimo chilometraggio",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    null,
                    11000);
                 if(result != null)
                 try
                 {
                	int maxKm = Integer.parseInt(result);
                	if(maxKm > 0)
                	{
	                	for(Auto auto : listAuto)
	                	{
	                		if(auto.getChilometraggio() <= maxKm)
	                			lista.add(auto);
	                	}
	                	riempiTabella(lista); 	
	                	currentList = lista;
	                }
	                else
	                {
	                	new AePlayWave("tristezza.wav").start();
	                	JOptionPane.showMessageDialog(GraphicConcessionariaFrame.this,
						    "Inserisci un valore superiore a 0!",
						    "Errore!",
						    JOptionPane.ERROR_MESSAGE);
						currentList = null;
						
				   }
                 }
                 catch(Exception exc)
                 {
                 	new AePlayWave("tristezza.wav").start();
                 	JOptionPane.showMessageDialog(GraphicConcessionariaFrame.this,
					    "Inserisci un valore superiore a 0!",
					    "Errore!",
					    JOptionPane.ERROR_MESSAGE);
					 currentList = null;
					
                 }
              else
              	currentList = null;
        	}
        }	
        );
        
        //Tipo
        menuTipo.addActionListener(
        new ActionListener()
        {
        	public void actionPerformed(ActionEvent e)
        	{
        		cancellaTabella();
        		java.util.List<Auto> lista = new Vector<Auto>();
        		String result = (String)JOptionPane.showInputDialog(
                    GraphicConcessionariaFrame.this, 
                    "Inserisci il tipo desiderato",
                    "Inserisci il tipo desiderato",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    new Object[]{"scenic","punto","seat","mercedes","uno","hammer"},
                    "scenic");
                 if(result != null)
                 {
	               	for(Auto auto : listAuto)
                	{
                		if(auto.getNome().equals(result))
                			lista.add(auto);
                	}
                	riempiTabella(lista); 
                	currentList = lista;	
                }
                else
                	currentList = lista;
        	}
        }	
        );
        
        //Colore
        menuColore.addActionListener(
        new ActionListener()
        {
        	public void actionPerformed(ActionEvent e)
        	{
        		cancellaTabella();
        		java.util.List<Auto> lista = new Vector<Auto>();
        		String result = (String)JOptionPane.showInputDialog(
                    GraphicConcessionariaFrame.this, 
                    "Inserisci il colore desiderato",
                    "Inserisci il colore desiderato",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    new Object[]{"rossa","blu","nera","grigia","bianca"},
                    "rossa");
                 if(result != null)
                 {
                	for(Auto auto : listAuto)
                	{
                		if(auto.getColore().equals(result))
                			lista.add(auto);
                	}
                	riempiTabella(lista); 	
                	currentList = lista;
                }
                else
                	currentList = null;
        	}
        }	
        );
        RadioHandler rh = new RadioHandler();
        radio1.addActionListener(rh); 	
        radio2.addActionListener(rh); 	
    }
    
    
    /**
     * Shutdown procedure when run as an application.
     */
    protected void windowClosed() 
    {
        System.exit(0);
    }
    
    private void cancellaTabella()
    {
    	int size = model.getRowCount();
			for(int i = size-1;i >=0; i--)
			{
				model.removeRow(i);
			}
    }
    
    private void riempiTabella(java.util.List<Auto> lista)
    {
		if(radio1.isSelected())
		{
			Collections.sort(lista);
		}
		else
		{
			Collections.sort(lista, new AutoComparator2());
		}
		for(Auto auto: lista)
		{
			model.addRow(new Object[]{auto.getNome(), auto.getPrezzo(), auto.getChilometraggio(), auto.getColore()});
		}
    }
    
    private void leggiAuto()
    {
    	try
    	{
    		listAuto = new Vector<Auto>();
    		Lettore leggiFile = new Lettore(new FileReader("auto.txt"));
    		while(!leggiFile.eof())
    		{
    			String linea = leggiFile.leggiLinea();
				StringTokenizer tokenizer = new StringTokenizer(linea," ");
				String nome = tokenizer.nextToken();
				int prezzo = Integer.valueOf(tokenizer.nextToken());
				int km = Integer.valueOf(tokenizer.nextToken());
				String colore = tokenizer.nextToken();
				listAuto.add(new Auto(nome,prezzo,km,colore));		
    		}
    		currentList = listAuto;
    	}
		catch(Exception e)
		{
			e.printStackTrace();
		}    	
    }
    
    private class RadioHandler implements ActionListener
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		cancellaTabella();
    		if(currentList != null)
    			riempiTabella(currentList);
    	}
    }
}
